/* Copyright (c) 2018 Griefer@Work                                            *
 *                                                                            *
 * This software is provided 'as-is', without any express or implied          *
 * warranty. In no event will the authors be held liable for any damages      *
 * arising from the use of this software.                                     *
 *                                                                            *
 * Permission is granted to anyone to use this software for any purpose,      *
 * including commercial applications, and to alter it and redistribute it     *
 * freely, subject to the following restrictions:                             *
 *                                                                            *
 * 1. The origin of this software must not be misrepresented; you must not    *
 *    claim that you wrote the original software. If you use this software    *
 *    in a product, an acknowledgement in the product documentation would be  *
 *    appreciated but is not required.                                        *
 * 2. Altered source versions must be plainly marked as such, and must not be *
 *    misrepresented as being the original software.                          *
 * 3. This notice may not be removed or altered from any source distribution. *
 */
#ifndef GUARD_KERNEL_INCLUDE_KERNEL_PROFILE_H
#define GUARD_KERNEL_INCLUDE_KERNEL_PROFILE_H 1

#include <hybrid/compiler.h>
#include <kos/types.h>
#include <hybrid/list/atree.h>

DECL_BEGIN

struct profiler {
    ATREE_NODE(struct profiler,uintptr_t) p_node; /* Profiler address range. */
    CHECKED VIRT u32                     *p_stat; /* [1..*][const] Profile statistics base address. */
    u32                                   p_gran; /* [const] Profiling granularity.
                                                   * This is the log2() value of how many consecutive
                                                   * bytes starting at `p_node.a_vmin' map to a single
                                                   * entry in the `p_stat' vector:
                                                   * >> TRIGGER(void *p):
                                                   * >>     ++p_stat[(p - p_node.a_vmin) >> p_gran]; */
};


DECL_END

#endif /* !GUARD_KERNEL_INCLUDE_KERNEL_PROFILE_H */
